; CDROM      Copyright (c)  Jannes Faber 1995
;
; You can contact me at :   faber@fys.ruu.nl
;           My www-page :   http://www.fys.ruu.nl/~faber
;
; This little program Opens & Closes your CD-ROM drive at the DOS-prompt.
;
; Syntax:       CDROM O         or      CDROM C
;
; I tried to make this COM-file as small as possible, so don't expect all
; that pretty on-line hyperhelptext in full color.
; It just opens or closes your drawer, or, if something isn't right, it 
; prints 'Err' on your screen. See the CDROM.TXT file for more info if things
; do go wrong !
;
; If anyone could tell me how to detect whether the drive is currently open
; or closed, i'd really appreciate it if you'd tell me ! I also would like
; to hear from you if you succeeded in making the COM-file significantly
; smaller than 73 bytes (not by changing the error-message into 'E' !).

        .MODEL TINY
        .CODE

        Org     5Dh
Params  LABEL   BYTE

        .STARTUP

        mov     cl, Params
        or      cl, 00100000y                   ; Convert to lowercase
        cmp     cl, 'o'
        jne     @F
        mov     cl, 0                           ; Open CD-rom
        jmp     OpenDev
@@:     cmp     cl, 'c'
        jne     Err
        mov     cl, 5                           ; Close CD-rom
        
OpenDev:
        ; Open Device using handle:
        mov     ax, 3D21h
        mov     dx, offset FileName
        int     21h
        jc      Err
        
        mov     ControlBlock, cl        ; Parameter Open or Close !

        mov     bx, ax                  ; file handle into bx
        mov     ax, 4403h               ; IOCTL function
        mov     cx, 1                   ; number of bytes to write
        ;mov     dx, offset ControlBlock ; 1 byte only to Open of Close
                                ; dx is already set: FileName == ControlBlock
        int     21h
        jnc     Einde

Err:    mov     dx, offset ShowErr      ; display error
        mov     ah, 9
        int     21h

Einde:  mov     ah, 4Ch                 ; exit program
        int     21h
                                                
ShowErr         BYTE    'Err$'
ControlBlock    LABEL   BYTE      ; offset ControlBlock == offset FileName
FileName        BYTE    'MSCD001', 0, 0
                
                END
